## supercollider 3.4.4

=== common/SConstruct ===
# -*- python -*- =======================================================
# FILE:         SConstruct
# CONTENTS:     scons build script for SuperCollider
# AUTHOR:       sk AT k-hornz DOT de
# modifications: nescivi AT gmail DOT com
# ======================================================================

# ======================================================================
# NOTE: Please use an indentation level of 4 spaces, i.e. no mixing of
# tabs and spaces.
# ======================================================================

# ======================================================================
# setup
# ======================================================================

EnsureSConsVersion(0,96)
EnsurePythonVersion(2,3)
SConsignFile()

# ======================================================================
# imports
# ======================================================================

import glob
import os
import subprocess
import re
import types
import tarfile
import platform   # Seems to have more portable uname() than os

# ======================================================================
# constants
# ======================================================================

PACKAGE = 'SuperCollider'



f = open('../VERSION')
VERSION = f.readline()
f.close()

def short_cpu_name(cpu):
    if cpu == 'Power Macintosh':
        cpu = 'ppc'
    return cpu.lower()

PLATFORM = platform.uname()[0].lower()
CPU = short_cpu_name(platform.uname()[4])

ANY_FILE_RE = re.compile('.*')
HELP_FILE_RE = re.compile('.*\.(rtf(d)?|scd|htm(l)?)$')
SC_FILE_RE = re.compile('.*\.sc$')
SRC_FILE_RE = re.compile('.*\.(c(pp)|h)$')

if PLATFORM == 'darwin':
    PLATFORM_SYMBOL = 'SC_DARWIN'
    PLUGIN_EXT = '.scx'
    DEFAULT_AUDIO_API = 'coreaudio'
    DEFAULT_PREFIX = '/usr/local'
elif PLATFORM == 'freebsd':
    PLATFORM_SYMBOL = 'SC_FREEBSD'
    PLUGIN_EXT = '.so'
    DEFAULT_AUDIO_API = 'jack'
    DEFAULT_PREFIX = '/usr/local'
elif PLATFORM == 'linux':
    PLATFORM_SYMBOL = 'SC_LINUX'
    PLUGIN_EXT = '.so'
    DEFAULT_AUDIO_API = 'jack'
    DEFAULT_PREFIX = '/usr/local'
elif PLATFORM == 'windows':
    PLATFORM_SYMBOL = 'SC_WIN32'
    PLUGIN_EXT = '.scx'
    DEFAULT_AUDIO_API = 'portaudio'
    DEFAULT_PREFIX = '/'
else:
    print 'Unknown platform: %s' % PLATFORM
    Exit(1)

if CPU in [ 'ppc' , 'ppc64' ]:
    DEFAULT_OPT_ARCH = '7450'
elif CPU in [ 'i586', 'i686' ]:
    # FIXME: better detection
    DEFAULT_OPT_ARCH = CPU
else:
    DEFAULT_OPT_ARCH = None

if PLATFORM != 'windows':
	subprocess.call(['sh', 'setMainVersion.sh'])


# ======================================================================
# util
# ======================================================================


def make_os_env(*keys):
    env = os.environ
    res = {}
    for key in keys:
        if env.has_key(key):
            res[key] = env[key]
    return res

def CheckPKGConfig(context, version):
    context.Message( 'Checking for pkg-config... ' )
    ret = context.TryAction('pkg-config --atleast-pkgconfig-version=%s' % version)[0]
    context.Result( ret )
    return ret

def CheckPKG(context, name):
    context.Message('Checking for %s... ' % name)
    ret = context.TryAction('pkg-config --exists \'%s\'' % name)[0]
    res = None
    if ret:
        res = Environment(ENV = make_os_env('PATH', 'PKG_CONFIG_PATH'))
        res.ParseConfig('pkg-config --cflags --libs \'%s\'' % name)
        res['PKGCONFIG'] = name
    context.Result(ret)
    return (ret, res)

def get_new_pkg_env():
    return Environment(ENV = make_os_env('PATH', 'PKG_CONFIG_PATH'))

def merge_lib_info(env, *others):
    for other in others:
        env.AppendUnique(CCFLAGS = other.get('CCFLAGS', []))
        env.AppendUnique(CPPDEFINES = other.get('CPPDEFINES', []))
        env.AppendUnique(CPPPATH = other.get('CPPPATH', []))
        env.AppendUnique(CXXFLAGS = other.get('CXXFLAGS', []))
        env.AppendUnique(LIBS = other.get('LIBS', []))
        env.AppendUnique(LIBPATH = other.get('LIBPATH', []))
        env['LINKFLAGS'] = env['LINKFLAGS'] + other.get('LINKFLAGS', "")

def make_pkgconfig_requires(*envs):
    res = []
    for env in envs:
        if env and env.has_key('PKGCONFIG'):
            res.append(env['PKGCONFIG'])
    return res

def build_pkgconfig_file(target, source, env):
    def write_field(file, name, prefix, separator=None):
        if env.has_key(name):
            if separator:
                content = separator.join(env[name])
            else:
                content = env[name]
            file.write('%s%s\n' % (prefix, content))
    out = file(str(target[0]), 'w')
    out.writelines([
        'prefix=%s\n' % env['PREFIX'],
        'exec_prefix=${prefix}\n',
        'libdir=${exec_prefix}/lib\n',
        'includedir=${prefix}/include/%s\n' % env['PACKAGE'],
        '\n'])
    write_field(out, 'PKGCONFIG_NAME', 'Name: ')
    write_field(out, 'PKGCONFIG_DESC', 'Description: ')
    write_field(out, 'URL', 'URL: ')
    write_field(out, 'VERSION', 'Version: ')
    write_field(out, 'PKGCONFIG_REQUIRES', 'Requires: ', ', ')
    write_field(out, 'PKGCONFIG_REQUIRES_PRIVATE', 'Requires.private: ', ', ')
    write_field(out, 'PKGCONFIG_LIBS', 'Libs: -L${libdir} ', ' ')
    write_field(out, 'PKGCONFIG_LIBS_PRIVATE', 'Libs.private: ', ' ')
    write_field(out, 'PKGCONFIG_CFLAGS', 'Cflags: ', ' ')
    out.close()

def flatten_dir(dir):
    res = []
    for root, dirs, files in os.walk(dir):
        if 'CVS' in dirs: dirs.remove('CVS')
        if '.svn' in dirs: dirs.remove('.svn')
        for f in files:
            res.append(os.path.join(root, f))
    return res

def install_dir(env, src_dir, dst_dir, filter_re, strip_levels=0):
    nodes = []
    for root, dirs, files in os.walk(src_dir):
        src_paths = []
        dst_paths = []
        if 'CVS' in dirs: dirs.remove('CVS')
        if '.svn' in dirs: dirs.remove('.svn')
        for d in dirs[:]:
            if filter_re.match(d):
                src_paths += flatten_dir(os.path.join(root, d))
                dirs.remove(d)
        for f in files:
            if filter_re.match(f):
                src_paths.append(os.path.join(root, f))
        dst_paths += map(
            lambda f:
            os.path.join(
            dst_dir,
            *f.split(os.path.sep)[strip_levels:]),
            src_paths)
        nodes += env.InstallAs(dst_paths, src_paths)
    return nodes

def is_installing():
    pat = re.compile('^install.*$')
    for x in COMMAND_LINE_TARGETS:
        if pat.match(x): return True
    return False

def is_home_directory(dir):
    return os.path.normpath(dir) == os.path.normpath(os.environ.get('HOME', '/'))

def bin_dir(prefix):
    return os.path.join(prefix, 'bin')
def lib_dir(prefix):
    return os.path.join(prefix, 'lib')

def pkg_data_dir(prefix, *args):
    if PLATFORM == 'darwin':
        base = '/Library/Application Support'
        if is_home_directory(prefix):
            base = os.path.join(prefix, base)
    else:
        base = os.path.join(prefix, 'share')
    return os.path.join(base, PACKAGE, *args)
def pkg_doc_dir(prefix, *args):
    if PLATFORM == 'darwin':
        base = '/Library/Documentation'
        if is_home_directory(prefix):
            base = os.path.join(prefix, base)
    else:
        base = os.path.join(prefix, 'share', 'doc')
    return os.path.join(base, PACKAGE, *args)
def pkg_include_dir(prefix, *args):
    return os.path.join(prefix, 'include', PACKAGE, *args)
def pkg_lib_dir(prefix, *args):
    return os.path.join(lib_dir(prefix), PACKAGE, *args)

def pkg_classlib_dir(prefix, *args):
    return pkg_data_dir(prefix, 'SCClassLibrary', *args)
def pkg_extension_dir(prefix, *args):
    return pkg_data_dir(prefix, 'Extensions', *args)

def make_opt_flags(env):
    flags = [
        "-O3",
        ## "-fomit-frame-pointer", # can behave strangely for sclang
        "-ffast-math",
        "-fno-finite-math-only",
        "-fstrength-reduce"
        ]
    arch = env.get('OPT_ARCH')
    if arch:
        if CPU in [ 'ppc' , 'ppc64' ]:
            flags.extend([ "-mcpu=%s" % (arch,) ])
        else:
            flags.extend([ "-march=%s" % (arch,) ])
    if CPU in [ 'ppc' , 'ppc64' ]:
        flags.extend([ "-fsigned-char", "-mhard-float",
                       ## "-mpowerpc-gpopt", # crashes sqrt
                       "-mpowerpc-gfxopt"
                       ])
    return flags

def make_static_object(env, source, postfix="_a"):
    obj = os.path.splitext(source)[0] + postfix
    return env.StaticObject(obj, source)

def make_static_objects(env, sources, postfix="_a"):
    return map(lambda x: make_static_object(env, x, postfix), sources)

# for linking libX.so => libX.so.1 on *nixy systems. Note, they must be in same dir.
def make_local_symlink(target, source, env):
    targetname = os.path.basename(str(target[0]))
    if os.path.isfile(targetname):
        if not os.path.islink(targetname):
            liblog.error("ERROR: cannot create symlink %s because already exists as non-symlink." % (targetname))
    else:
	    os.symlink(os.path.basename(str(source[0])), targetname)
    return None

# for linking libX.so => libX.so.1 on *nixy systems. Note, they must be in same dir.
def make_local_symlink(target, source, env):
    targetname = os.path.basename(str(target[0]))
    if os.path.isfile(targetname):
        if not os.path.islink(targetname):
            liblog.error("ERROR: cannot create symlink %s because already exists as non-symlink." % (targetname))
    else:
	    os.symlink(os.path.basename(str(source[0])), targetname)
    return None

# ======================================================================
# command line options
# ======================================================================

opts = Options('scache.conf', ARGUMENTS)
opts.AddOptions(
    BoolOption('ALSA',
               'Build with ALSA sequencer support', 1),
    BoolOption('ALTIVEC',
               'Build with Altivec support', 1),
    ('OPT_ARCH', 'Architecture to optimize for', DEFAULT_OPT_ARCH),
    EnumOption('AUDIOAPI',
               'Build with specified audio API support',
               DEFAULT_AUDIO_API, ('jack', 'coreaudio', 'portaudio')),
    ('CC', 'C compiler executable'),
    ('CCFLAGS', 'C compiler flags'),
    ('CXX', 'C++ compiler executable'),
    ('CXXFLAGS', 'C++ compiler flags'),
    BoolOption('DEBUG',
               'Build with debugging information', 0),
    PathOption('DESTDIR',
               'Intermediate installation prefix for packaging', '/',
               PathOption.PathAccept),
    BoolOption('DEVELOPMENT',
               'Build and install the development files', 0),
    BoolOption('FFTW',
               'Use the FFTW libraries', PLATFORM != 'darwin'),
    BoolOption('JACK_DLL',
               'Build with delay locked loop support', 0),
    BoolOption('JACK_DEBUG_DLL',
               'Build with delay locked loop debugging support', 0),
    BoolOption('LANG',
               'Build the language application', 1),
    BoolOption('LID',
               'Build with Linux Input Device support [linux]', PLATFORM == 'linux'),
    BoolOption('NO_LIBSNDFILE',
               'Disable libsndfile (audio file reading/writing)', 0),
    BoolOption('WII',
               'Build with Linux WII support [linux]', PLATFORM == 'linux'),
    PathOption('PREFIX',
               'Installation prefix', DEFAULT_PREFIX),
    BoolOption('RENDEZVOUS',
               'Enable Zeroconf/Rendezvous.', 1),
    BoolOption('SCEL',
               'Enable the SCEL user interface; NOTE for the HTML help system you need emacs-w3m', 1),
    BoolOption('SCVIM',
               'Enable the SCVIM user interface; NOTE see the README in /editors/scvim for setting variables', 1),
    BoolOption('SCED',
               'Enable the SCED (based on gedit) user interface; NOTE see the README in /editors/sced for setting variables', 0),
    BoolOption('SSE',
               'Build with SSE support', 1),
    BoolOption('SSE2',

=== common/include/nova-simd/libsimdmath/Makefile ===
# PROCESSOR must be one of SSE, PPU, or SPU
PROCESSOR := SSE


export PROCESSOR

all:
	cd lib   && $(MAKE)
	cd tests && $(MAKE) test
	cd tests && $(MAKE) tlibm
#	cd tests && $(MAKE) tps3m
#	cd tests && $(MAKE) tveclib

clean:	
	cd lib   && $(MAKE) clean
	cd tests && $(MAKE) clean

=== common/include/nova-simd/testsuite/CMakeLists.txt ===
set(tests
  ampmod_test.cpp
  simd_binary_tests.cpp
  simd_math_tests.cpp
  simd_memory_tests.cpp
  simd_mix_tests.cpp
  simd_pan_tests.cpp
  simd_peak_tests.cpp
  simd_round_tests.cpp
  simd_ternary_tests.cpp
  simd_tests.cpp
  simd_unary_tests.cpp
  softclip_test.cpp
)

# build benchmarks
foreach(test ${tests})
  string(REPLACE .cpp "" test_name ${test} )
  add_executable(${test_name} ${test})
  add_test(${test_name}_run ${EXECUTABLE_OUTPUT_PATH}/${test_name})
endforeach(test)

=== debian/changelog ===
supercollider (1:3.4.4-2) unstable; urgency=low

  * Team upload.
  * Disable building of gedit2 plugin. Closes: #635118

 -- Felipe Sateler <fsateler@debian.org>  Fri, 28 Oct 2011 23:30:39 -0300

supercollider (1:3.4.4-1) unstable; urgency=low

  [ Alexandre Quessy ]
  * Initial release for debian (Closes: #602050).
  * Little cleanup in dependencies
  * Build-Depend on libsndfile1-dev - the 1 is mandatory
  * Use format 3.0 (quilt)
  * Make sure short descriptions are not duplicates

  [ Felipe Sateler ]
  * Add myself to Uploaders
  * Use the cdbs scons class
    - Tighten build-dep on cdbs for scons class support
  * Add DEP-3 headers to patches
  * Fix BSD license section in copyright file
  * Bump Standards-Version
  * Make use of dh_lintian instead of manually installing overrides
  * Override lintian warnings:
    - emacs command not in package, supercollider-emacs depends on emacs
    - missing xpm, supercollider depends on supercollider-common
    - empty directory, it is intentional
  * Build-Depend on libcwiid-dev instead of dropped libcwiid1-dev
  * Use single space after fields in debian/control
  * Qualify build dependency on libasound for use only on linux archs
  * Switch from pysupport to dh_python2

  [ Dan Stowell ]
  * Imported Upstream version 3.4.4
  * Apple copyright not needed, apple files not bundled
  * Can build against jack2 as well as jack1
  * Update copyright to match rearranged folders and stripped linux
    source tgz
  * Combine -dev packages into one supercollider-dev
    - Merged -dev package Conflicts+Replaces+Provides predecessors
  * Handle DEB_BUILD_OPTIONS to control strip/optimise
  * Don't strip in rules (let dh_strip decide)
  * Update copyright with full dates+authors (largely from SCM analysis)

  [ Jonas Smedegaard ]
  * Ease building with git-buildpackage:
    + Git-ignore quilt .pc dir.
    + Add dpkg-source local-options hints.
  * Update copyright file:
    + Drop superfluous X-Packaged-By fields (covered by Files section
    + debian/* and - for more accurate times - file debian/control).
    + Move license texts to License sections, sorted roughly by
      similarity with main licensing terms.
    + Reorder Files sections sorted by amount of files, first upstream
      and then debian packaging.
    + Stop listing WiiMote_OSX Files section apparently no longer
      included.
    + Tighten DEP-5 format to draft rev. 174.
    + Extend with additional copyright holders.
  * Enable CDBS utils.mk snippet, for copyright-check routine.

 -- Felipe Sateler <fsateler@debian.org>  Tue, 19 Jul 2011 22:18:02 -0400

supercollider (1:3.3.2~svn9887-0ubuntu1~lucid1) lucid; urgency=low

  * First build for Ubuntu.

 -- Артём Попов <artfwo@gmail.com>  Fri, 26 Feb 2010 09:34:09 +0600

supercollider (1:3.3.2~svn9887-0) UNRELEASED; urgency=low

  [ Артём Попов ]
  * New upstream release (LP: #183552). Repackaged from scratch
    (with manpages adapted from the original package).

  [ Dan Stowell]
  * Improve behaviour of "scvim" desktop icon: visible user prompt
    about vim-addon-manager if needed.
  * Desktop files and icons integration.
  * Update packaging rules for reorganised folders.
  * Update and extend manpages for scvim.
  * Added debian menu files.
  * Dependencies, architeture, copyright and lintian fixes.

 -- Артём Попов <artfwo@gmail.com>  Fri, 26 Feb 2010 09:34:09 +0600

supercollider (20060416-1build1) gutsy; urgency=low

  * Rebuild for the libflac transition.

 -- Steve Kowalik <stevenk@ubuntu.com>  Tue, 10 Jul 2007 15:31:52 +1000

supercollider (20060416-1) unstable; urgency=low

  * New upstream release
  * Removed erroneous architecture fields in Suggests (closes: #356372)
  * Activated RendezVous build, added Build-depends on libavahi-client-dev
  * Bump sonames to libsclang.so.1 and libscsynth.so.1
  * Move supercollider-doc to Section: doc

 -- Paul Brossier <piem@debian.org>  Tue, 18 Apr 2006 12:28:40 +0200

supercollider (20051211-1) unstable; urgency=low

  * New upstream release
  * Prevent byte-compilation for xemacs (closes: #338169, #342358)
  * sclang is now to be compiled only on supported platforms
  	(closes: #276212, #290339)
  * 10fix_emacs_help.dpatch: fix path for Help 

 -- Paul Brossier <piem@debian.org>  Mon, 12 Dec 2005 10:12:21 +0000

supercollider (20050921-1) unstable; urgency=low

  * New upstream release
  * Removed patch 60SC_Lib_dlopen and 100fix_gcc4, merged upstream.
  * Added 20virtual_parsenode to prevent virtual destructor g++-4.0 warnings
  * Drop supercollider package on architectures where test failed. The
    supercollider-server package remains available on all platforms. Also drop
    libsclang on these machines.

 -- Paul Brossier <piem@debian.org>  Thu, 22 Sep 2005 03:42:14 +0100

supercollider (20050624-1) unstable; urgency=low

  Paul Brossier:
    * New upstream release
    * Updated rules to follow the move to scons
    * Added scons and removed emacsen first in Build-Deps
    * Updated 10emacs, 60SC_Lib_dlopen, 70fix_some_warnings
    * Adds 80remove_pragmas
    * Removed 80fix_sclang.conf
    * Bumped Standards-Version
    * Splitted supercollider into supercollider, supercollider-server,
      libsclang0 and libscsynth0. supercollider-dev now provides libsclang-dev
      and libscsynth-dev

  Mario Lang:
    * Execute the scons install target.
    * Patch SConstruct to avoid Emacs byte-compilation at build-time.
    * Use a emcsen-install script to perform byte-compilation
      at package install time to be conformant with Debian Emacs Policy.
    * Put plugins in libscsynth0 so that both either client-only
      installations (with internal server) and server only installations
      (no client package installed) work correctly.
    * Move .rtf docs to /usr/share/SuperCollider/Help (as upstream
      does by default) and symlink from /usr/share/doc/supercollider-doc/Help.
    * Build against latest jackd (closes: #317225)


=== debian/control ===
Source: supercollider
Section: sound
Priority: optional
Vcs-Git: git://git.debian.org/pkg-multimedia/supercollider.git
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/supercollider.git;a=summary
Maintainer: Debian Multimedia Packages Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Alexandre Quessy <alexandre@quessy.net>,
 Felipe Sateler <fsateler@debian.org>,
 Dan Stowell <danstowell@users.sourceforge.net>
Build-Depends: 
 cdbs (>= 0.4.73~),
 debhelper (>= 6),
 libasound2-dev [linux-any],
 libavahi-client-dev,
 libcwiid-dev,
 libfftw3-dev,
 libicu-dev,
 libjack-dev,
 libreadline-dev,
 libsndfile1-dev (>= 1.0.16),
 libxt-dev,
 python-all-dev (>= 2.6.6-3~),
 scons (>= 0.96)
Standards-Version: 3.9.2
Homepage: http://supercollider.sourceforge.net/

Package: supercollider
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
  supercollider-common (= ${source:Version}),
  supercollider-server
Suggests: subversion, supercollider-doc
Description: real time audio synthesis programming language
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package contains the language interpreter.

Package: libsclang1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: SuperCollider language interpreter library
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package contains the shared library for the language interpreter.

Package: supercollider-common
Architecture: all
Depends: ${misc:Depends}
Description: common files for SuperCollider
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package contains the architecture independent files for SuperCollider.

Package: supercollider-server
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, jackd
Description: real time audio synthesis server
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package contains the synthesis server.

Package: libscsynth1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: SuperCollider synthesis server library
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package contains the shared library for the synthesis server.

Package: supercollider-dev
Architecture: any
Depends: ${misc:Depends},
  supercollider (= ${binary:Version}),
  libsndfile1-dev (>= 1.0.16)
Conflicts: supercollider-common-dev, supercollider-server-dev
Replaces: supercollider-common-dev, supercollider-server-dev
Provides: supercollider-common-dev, supercollider-server-dev
Description: development files for SuperCollider
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package contains the development files and headers.

Package: supercollider-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: supercollider
Description: documentation for SuperCollider
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package contains the HTML documentation for SuperCollider.

Package: supercollider-emacs
Architecture: all
Depends: ${misc:Depends},
  supercollider (>= ${source:Version}),
  emacs23 | emacsen
Recommends: supercollider-doc, w3m-el
Description: SuperCollider mode for Emacs
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package provides the SuperCollider mode for Emacs.
 .
 Package supercollider-doc is suggested so that the editor can show help
 documentation in context.

Package: supercollider-vim
Architecture: all
Depends: ${misc:Depends},
  supercollider (>= ${source:Version}), vim | gvim, ruby
Recommends: supercollider-doc, unhtml | links, vim-addon-manager
Suggests: unrtf
Description: SuperCollider mode for Vim
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package provides the SuperCollider mode for Vim.
 .
 Package supercollider-doc is suggested so that the editor can show help
 documentation in context.

=== debian/rules ===
#! /usr/bin/make -f

include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/scons.mk

DEB_BUILDDIR=common

# Add here any variable or target overrides you need.
DEB_DH_INSTALL_SOURCEDIR=debian/tmp
export CDBS_NO_DOC_SYMLINKING:=1

# Do not enable parallel building: scons cannot handle parallel
# builds when the chdir option is used in any command
# DEB_BUILD_PARALLEL = 1

DEB_INSTALL_DOCS_supercollider             = "README LINUX" common/build/README
DEB_INSTALL_DOCS_supercollider-server      = "README LINUX" common/build/README
DEB_INSTALL_DOCS_supercollider-emacs       = editors/scel/README
DEB_INSTALL_DOCS_supercollider-vim         = editors/scvim/README editors/scvim/SCVim.scd
DEB_INSTALL_CHANGELOGS_ALL                 = common/build/ChangeLog

DEB_INSTALL_MANPAGES_supercollider-server  = debian/scsynth.1
DEB_INSTALL_MANPAGES_supercollider         = debian/sclang.1
DEB_INSTALL_MANPAGES_supercollider-vim     = debian/scvim.1 debian/scvim_make_help.1 debian/sclangpipe_app.1

# recent SVN revisions also install examples to $(DEB_DESTDIR)/usr/share
DEB_INSTALL_EXAMPLES_supercollider         = common/build/examples/*
DEB_INSTALL_DIRS_supercollider             = usr/share/SuperCollider/Extensions

# SCVIM/SCED=0 here, because we install them by hand below
# (so that the build won't break)
# Also STRIP=0 since we let cdbs (dh_strip) decide whether to strip
DEB_SCONS_OPTIONS = DEVELOPMENT=yes PREFIX=/usr CROSSCOMPILE=1 CURL=0 SCVIM=0 SCED=0 STRIP=0
# Handle DEB_BUILD_OPTIONS (see policy 4.9.1)
ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_OPTIONS += "DEBUG=1"
endif

DEB_SCONS_INSTALL_TARGET = DESTDIR=$(DEB_DESTDIR) install

# The build system apparently can't handle this
CXXFLAGS =

clean:: scons-clean
scons-clean::
	dh_testdir
	scons -C common $(SCONS_FLAGS) --clean scrub
	rm -f common/.sconsign.dblite
	rm -f editors/scvim/.sconsign.dblite
	rm -f editors/sced/.sconsign.dblite
	# also remove some files, that SCons forgets about
	rm -f editors/scel/el/sclang-vars.el
	rm -f linux/libsclang.pc
	rm -f linux/libscplugin.pc
	rm -f linux/libscsynth.pc

common-install-arch common-install-indep:: common-install-impl
common-install-impl::
	scons --install-sandbox=$(DEB_DESTDIR) --directory=editors/scvim PREFIX=/usr VIMFILE_DIR=/usr/share/vim/addons install-all
	scons --install-sandbox=$(DEB_DESTDIR) --directory=editors/sced PREFIX=/usr install
	# fixing some executables in class library and docs for happier lintian
	find $(DEB_DESTDIR)/usr/share/SuperCollider -type d -exec chmod 755 {} \;; \
	find $(DEB_DESTDIR)/usr/share/SuperCollider -type f -exec chmod 644 {} \;; \
	# vim-addon-manager stuff
	install -d $(DEB_DESTDIR)/usr/share/vim/registry
	install -m 644 debian/supercollider-vim.yaml $(DEB_DESTDIR)/usr/share/vim/registry
	# lintian overrides
	install -m 644 debian/README.extensions $(DEB_DESTDIR)/usr/share/SuperCollider/Extensions/README
	# icons and metadata for freedesktop-style menu entries
	install -d $(DEB_DESTDIR)/usr/share/applications
	install -m 644 debian/*.desktop $(DEB_DESTDIR)/usr/share/applications
	install -d $(DEB_DESTDIR)/usr/share/pixmaps
	install -m 644 linux/icons/supercollider.xpm $(DEB_DESTDIR)/usr/share/pixmaps
	install -m 644 linux/icons/supercollider.png $(DEB_DESTDIR)/usr/share/pixmaps
